	list	p=16F84
	#include p16F84.inc
	__CONFIG  _XT_OSC&_WDT_OFF	
CODE_1	EQU	H'000C'
CODE_2	EQU	H'000D'
CODE_3	EQU	H'000E'
CODE_4	EQU	H'000F'
AP_1	EQU	H'0010'
AP_2	EQU	H'0011'
AP_3	EQU	H'0012'
AP_4	EQU	H'0013'
CHIFFRE	EQU	H'0014'
COMPTEUR	EQU	H'0015'
IMPUL	EQU	H'0016'
ERREUR	EQU	H'0017'
REL_1	EQU	H'0018'
REL_2	EQU	H'0019'
ADRESSE	EQU	H'001A'
DONNEE	EQU	H'001B'
I	EQU	H'001C'
VBFOR1	EQU	H'001D'
V_PS_1	EQU	H'001E'
V_PS_2	EQU	H'001F'
V_PS_3	EQU	H'0020'
V_PS_10	EQU	H'0021'
V_PS_20	EQU	H'0022'
V_PS_30	EQU	H'0023'
VARIF	EQU	H'0024'
PER_NOTE1	EQU	H'0025'
PER_NOTE2	EQU	H'0026'
DUREE_NOTE	EQU	H'0027'
;(1) LES TIQUETTES ET VARIABLES
;(2) ECRITURE EEPROM INITIALE, RELAIS OUVERTS
	ORG H'2100'
	DE 0,0
;(3) INITIALISATION DES PORTS OU REGISTRES
	ORG 0
	BSF STATUS,RP0
	MOVLW	H'8F'
	MOVWF	TRISB
	MOVLW	H'10'
	MOVWF	TRISA
	BCF STATUS,RP0
;(4) VERIFICATION PROGRAMMATION
	MOVLW	H'00'
	MOVWF	I
	SUBLW	H'02'
	MOVWF	VBFOR1
	INCF	VBFOR1,1
SP_FOR1	NOP
	BSF PORTB,6
	MOVLW	H'0A'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	BCF PORTB,6
	MOVLW	H'0A'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	INCF	I,1
	DECFSZ	VBFOR1,1
	GOTO	SP_FOR1
;(5) CODE D'ACCES 4321
	MOVLW	H'02'
	MOVWF	CODE_1
	MOVLW	H'0C'
	MOVWF	CODE_2
	MOVLW	H'04'
	MOVWF	CODE_3
	MOVLW	H'08'
	MOVWF	CODE_4
;(6) LECTURE EEPROM
	MOVLW	H'00'
	MOVWF	ADRESSE
	CALL	R_EEPROM
	MOVF	DONNEE,0
	MOVWF	REL_1
	MOVLW	H'01'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'01'
	MOVWF	ADRESSE
	CALL	R_EEPROM
	MOVF	DONNEE,0
	MOVWF	REL_2
	MOVLW	H'01'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVF	REL_1,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE1
	BSF PORTB,4
	GOTO	ENDIF1
ELSE1	NOP
	BCF PORTB,4
ENDIF1	NOP
	MOVF	REL_2,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE2
	BSF PORTB,5
	GOTO	ENDIF2
ELSE2	NOP
	BCF PORTB,5
ENDIF2	NOP
;(7) SOMMEIL ET ATTENTE SONNERIE 4 FOIS
PRIN	BCF PORTA,2
	BCF PORTB,6
	MOVLW	H'08'
	MOVWF	INTCON
	SLEEP
	MOVLW	H'00'
	MOVWF	COMPTEUR
	MOVLW	H'00'
	MOVWF	IMPUL
N1_B	BTFSC PORTB,7
	GOTO	N_IMPUL
	INCF COMPTEUR,1
	MOVLW	H'01'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVF	COMPTEUR,0
	SUBLW	H'28'
	BTFSC	STATUS,C
	GOTO	ELSE3
	GOTO	PRIN
	GOTO	ENDIF3
ELSE3	NOP
	GOTO	N1_B
ENDIF3	NOP
N_IMPUL	INCF IMPUL,1
	MOVLW	H'00'
	MOVWF	COMPTEUR
	BSF PORTB,6
	MOVLW	H'05'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	BCF PORTB,6
	MOVF	IMPUL,0
	SUBLW	H'04'
	BTFSS	STATUS,Z
	GOTO	ELSE4
	GOTO	DECRO
	GOTO	ENDIF4
ELSE4	NOP
	MOVLW	H'23'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
N1_H	BTFSC PORTB,7
	GOTO	N1_H
	GOTO	N1_B
ENDIF4	NOP
;(8) DECROCHAGE
DECRO	BSF PORTA,2
	BSF PORTB,6
	MOVLW	H'32'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
;(9) ATTENTE CODE D'ACCES DE 4 TONALITS
	CALL	ATT_C
	MOVF	ERREUR,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE5
	GOTO	PRIN
ELSE5	NOP
	MOVF	CHIFFRE,0
	MOVWF	AP_1
	CALL	ATT_C
	MOVF	ERREUR,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE6
	GOTO	PRIN
ELSE6	NOP
	MOVF	CHIFFRE,0
	MOVWF	AP_2
	CALL	ATT_C
	MOVF	ERREUR,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE7
	GOTO	PRIN
ELSE7	NOP
	MOVF	CHIFFRE,0
	MOVWF	AP_3
	CALL	ATT_C
	MOVF	ERREUR,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE8
	GOTO	PRIN
ELSE8	NOP
	MOVF	CHIFFRE,0
	MOVWF	AP_4
;(10) VERIFICATION DU CODE
	MOVF	AP_1,0
	SUBWF	CODE_1,0
	BTFSC	STATUS,Z
	GOTO	ELSE9
	GOTO	PRIN
ELSE9	NOP
	MOVF	AP_2,0
	SUBWF	CODE_2,0
	BTFSC	STATUS,Z
	GOTO	ELSE10
	GOTO	PRIN
ELSE10	NOP
	MOVF	AP_3,0
	SUBWF	CODE_3,0
	BTFSC	STATUS,Z
	GOTO	ELSE11
	GOTO	PRIN
ELSE11	NOP
	MOVF	AP_4,0
	SUBWF	CODE_4,0
	BTFSC	STATUS,Z
	GOTO	ELSE12
	GOTO	PRIN
ELSE12	NOP
; (11) CODE D'ACCES BON , MUSIQUE ET SUITE
	MOVLW	H'0A'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'BE'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'AA'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'97'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'AA'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'BE'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'0A'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
;(12) ATTENTE DES ORDRES
ORDRE	CALL	ATT_C
	MOVF	ERREUR,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE13
	GOTO	PRIN
ELSE13	NOP
;(13) TRAITEMENT DES ORDRES
;SI 1 , ENVOIE L'TAT DU RELAIS 1
	MOVF	CHIFFRE,0
	SUBLW	H'08'
	BTFSS	STATUS,Z
	GOTO	ELSE14
	MOVF	REL_1,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE15
	CALL	ENVOI_ON
	GOTO	ENDIF15
ELSE15	NOP
	CALL	ENVOI_OFF
ENDIF15	NOP
ELSE14	NOP
;SI 2 , ENVOIE L'TAT DU RELAIS 2
	MOVF	CHIFFRE,0
	SUBLW	H'04'
	BTFSS	STATUS,Z
	GOTO	ELSE16
	MOVF	REL_2,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE17
	CALL	ENVOI_ON
	GOTO	ENDIF17
ELSE17	NOP
	CALL	ENVOI_OFF
ENDIF17	NOP
ELSE16	NOP
;SI 4 , RELAIS 1SUR ON
	MOVF	CHIFFRE,0
	SUBLW	H'02'
	BTFSS	STATUS,Z
	GOTO	ELSE18
	MOVLW	H'01'
	MOVWF	REL_1
	BSF PORTB,4
	MOVLW	H'00'
	MOVWF	ADRESSE
	MOVLW	H'01'
	MOVWF	DONNEE
	CALL	W_EEPROM
ELSE18	NOP
;SI 5 , RELAIS 2 SUR ON
	MOVF	CHIFFRE,0
	SUBLW	H'0A'
	BTFSS	STATUS,Z
	GOTO	ELSE19
	MOVLW	H'01'
	MOVWF	REL_2
	BSF PORTB,5
	MOVLW	H'01'
	MOVWF	ADRESSE
	MOVLW	H'01'
	MOVWF	DONNEE
	CALL	W_EEPROM
ELSE19	NOP
;SI 7 , RELAIS 1SUR OFF
	MOVF	CHIFFRE,0
	SUBLW	H'0E'
	BTFSS	STATUS,Z
	GOTO	ELSE20
	MOVLW	H'00'
	MOVWF	REL_1
	BCF PORTB,4
	MOVLW	H'00'
	MOVWF	ADRESSE
	MOVLW	H'00'
	MOVWF	DONNEE
	CALL	W_EEPROM
ELSE20	NOP
;SI 8 , RELAIS 2 SUR OFF
	MOVF	CHIFFRE,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE21
	MOVLW	H'00'
	MOVWF	REL_2
	BCF PORTB,5
	MOVLW	H'01'
	MOVWF	ADRESSE
	MOVLW	H'00'
	MOVWF	DONNEE
	CALL	W_EEPROM
ELSE21	NOP
;SI DISE , RACCROCHE SANS ATTENDRE
	MOVF	CHIFFRE,0
	SUBLW	H'03'
	BTFSS	STATUS,Z
	GOTO	ELSE22
	GOTO	PRIN
ELSE22	NOP
	CALL	ORDRE
;(14) ATTENTE CHIFFRES
ATT_C	MOVLW	H'00'
	MOVWF	COMPTEUR
	MOVLW	H'00'
	MOVWF	ERREUR
AT_C	BTFSC PORTA,4
	GOTO	CHIF
	INCF COMPTEUR,1
	MOVLW	H'02'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVF	COMPTEUR,0
	SUBLW	H'C8'
	BTFSC	STATUS,C
	GOTO	ELSE23
	MOVLW	H'01'
	MOVWF	ERREUR
	RETURN
ELSE23	NOP
	GOTO	AT_C
CHIF	MOVF	PORTB,0
	ANDLW	H'0F'
	MOVWF	CHIFFRE
ATT_B1	BTFSC PORTA,4
	GOTO	ATT_B1
	MOVLW	H'02'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'32'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	RETURN
;(15) SONORIT ON
ENVOI_ON	MOVLW	H'05'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'5F'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'03'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'5F'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	RETURN
;(16) SONORIT OFF
ENVOI_OFF	MOVLW	H'05'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'50'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'02'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'50'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'02'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'50'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	MOVLW	H'02'
	MOVWF	V_PS_3
	MOVLW	H'0A'
	MOVWF	V_PS_2
	MOVLW	H'0A'
	MOVWF	V_PS_1
	CALL	SP_PAUSE
	MOVLW	H'50'
	MOVWF	PER_NOTE1
	CALL	SP_SOUND
	RETURN
;(17) ECRITURE DANS EEPROM 
W_EEPROM	MOVF	ADRESSE,0
	MOVWF	EEADR
	MOVF	DONNEE,0
	MOVWF	EEDATA
	BSF	STATUS, RP0
	BSF	EECON1, WREN
	MOVLW	H'55'
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR
	BCF	STATUS, RP0
	RETURN
;(18) LECTURE DE L'EEPROM 
R_EEPROM	MOVF	ADRESSE,0
	MOVWF	EEADR
	BSF	STATUS,RP0	
	BSF	EECON1,RD	
	BCF	STATUS,RP0	
	MOVF	EEDATA,0
	MOVWF	DONNEE
	RETURN
	GOTO	F1PR_G
SP_PAUSE	MOVF	V_PS_1,0
	MOVWF	V_PS_10
SP_PAUSE0	MOVF	V_PS_2,0
	MOVWF	V_PS_20
SP_PAUSE1	MOVLW	H'F9'
	MOVWF	V_PS_30
SP_PAUSE2	NOP
	DECFSZ	V_PS_30,1
	GOTO	SP_PAUSE2
	DECFSZ	V_PS_20,1
	GOTO	SP_PAUSE1
	DECFSZ	V_PS_10,1
	GOTO	SP_PAUSE0
	DECFSZ	V_PS_3,1
	GOTO	SP_PAUSE
	RETURN
SP_SOUND	CALL	SP_OSCIL
	DECFSZ	DUREE_NOTE, 1
	GOTO	SP_SOUND
	RETURN
SP_OSCIL	MOVF	PER_NOTE1,0
	MOVWF	PER_NOTE2
	BSF	PORTA , H'03'
	CALL	SP_DEMIP
	MOVF	PER_NOTE1,0 
	MOVWF	PER_NOTE2
	BCF	PORTA , H'03'
	CALL	SP_DEMIP  
	RETURN
SP_DEMIP	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECFSZ	PER_NOTE2,1
	GOTO	SP_DEMIP
	RETURN
F1PR_G	NOP
	END
